/////////////////////////////////////////////////////////////////////////////
//
// CookieDlg.cpp : implementation file
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CookieDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "CookieDlgAbout.h"

/////////////////////////////////////////////////////////////////////////////
// CCookieDlg dialog
CCookieDlg::CCookieDlg(CWnd *pParent /*=NULL*/)
	: CDialog(CCookieDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCookieDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

//Deine the cookie class
	Cookie = new CCookieText(pParent);

}

/////////////////////////////////////////////////////////////////////////////
// Destructor
CCookieDlg::~CCookieDlg()
{
delete Cookie;
}

/////////////////////////////////////////////////////////////////////////////
void CCookieDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCookieDlg)
	DDX_Control(pDX, IDC_SPIN_SELECT_COOKIE, m_SpinSelectCookie);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CCookieDlg message handlers
/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CCookieDlg, CDialog)
	//{{AFX_MSG_MAP(CCookieDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_ABOUT, OnBtnAbout)
	ON_BN_CLICKED(IDC_BTN_AGAIN, OnBtnAgain)
	ON_BN_CLICKED(IDC_BTN_FIRST, OnBtnFirst)
	ON_BN_CLICKED(IDC_BTN_LAST, OnBtnLast)
	ON_BN_CLICKED(IDC_BTN_PREVIOUS, OnBtnPrevious)
	ON_BN_CLICKED(IDC_BTN_NEXT, OnBtnNext)
	ON_BN_CLICKED(IDC_BTN_GO, OnBtnGoto)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
BOOL CCookieDlg::OnInitDialog()
{
CDialog::OnInitDialog();

// Add "About..." menu item to system menu.
// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
    	{
	    pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	    }

// Set the icon for this dialog.  The framework does this automatically
//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


// Setup the Bitmap Buttons
    VERIFY(CookieDlg_Quit.SubclassDlgItem(IDOK, this));
    VERIFY(CookieDlg_Quit.LoadBitmaps(BB_QUIT_UP, BB_QUIT_DOWN, BB_QUIT_SEL));
    VERIFY(CookieDlg_Again.SubclassDlgItem(IDC_BTN_AGAIN, this));
    VERIFY(CookieDlg_Again.LoadBitmaps(BB_AGAIN_UP, BB_AGAIN_DOWN, BB_AGAIN_SEL));
    VERIFY(CookieDlg_About.SubclassDlgItem(IDC_BTN_ABOUT, this));
    VERIFY(CookieDlg_About.LoadBitmaps(BB_ABOUT_UP, BB_ABOUT_DOWN, BB_ABOUT_SEL));


// Set up the spinny thing...
    m_SpinSelectCookie.SetRange(1,Cookie->GetCookieCount());

// Get a Cookie and shove it in the text box... 
    DoRandom();

// return TRUE  unless you set the focus to a control
    return TRUE;  
}

/////////////////////////////////////////////////////////////////////////////
void CCookieDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


/////////////////////////////////////////////////////////////////////////////
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CCookieDlg::OnPaint() 
{
if (IsIconic())
    {
    CPaintDC dc(this); // device context for painting

    SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

    // Center icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    // Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
    }
else
    {
    CDialog::OnPaint();
    }
}

/////////////////////////////////////////////////////////////////////////////
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCookieDlg::OnQueryDragIcon()
{
return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////
//
void CCookieDlg::OnBtnAgain() 
{
DoRandom();
}

/////////////////////////////////////////////////////////////////////////////
void CCookieDlg::OnBtnAbout() 
{
CAboutDlg dlgAbout;

dlgAbout.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
void CCookieDlg::OnBtnFirst() 
{
DoSpecific(0);
}

/////////////////////////////////////////////////////////////////////////////
void CCookieDlg::OnBtnLast() 
{
DoSpecific(Cookie->GetCookieCount() -1 );
}

/////////////////////////////////////////////////////////////////////////////
void CCookieDlg::OnBtnPrevious() 
{
UINT temp = (Cookie->GetCookieCurrent());
if( temp != 0)
    DoSpecific(temp - 1);
}

/////////////////////////////////////////////////////////////////////////////
//
void CCookieDlg::OnBtnNext() 
{
UINT temp = (Cookie->GetCookieCurrent() + 1);
if( temp != (Cookie->GetCookieCount()))
    DoSpecific(temp);
}


/////////////////////////////////////////////////////////////////////////////
// The functional function start here...
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//
void CCookieDlg::DoRandom()
{
CEdit	*ptr_Cookie;

ptr_Cookie = (CEdit*) GetDlgItem(IDC_EDIT_COOKIE);
if (ptr_Cookie != NULL)
	ptr_Cookie->SetWindowText(*Cookie->GetRandomCookie());

DoBanner();
}

/////////////////////////////////////////////////////////////////////////////
//
void CCookieDlg::DoSpecific(UINT CookieNum)
{
CEdit	*ptr_Cookie;

ptr_Cookie = (CEdit*) GetDlgItem(IDC_EDIT_COOKIE);
if (ptr_Cookie != NULL)
	ptr_Cookie->SetWindowText(*Cookie->GetSpecificCookie(CookieNum));

DoBanner();
}

/////////////////////////////////////////////////////////////////////////////
//
void CCookieDlg::DoBanner()
{
CString     fmtBanner;
CString     outBanner;

fmtBanner.LoadString(IDS_DLG_BANNER);
outBanner.Format(fmtBanner, (Cookie->GetCookieCurrent() + 1), (Cookie->GetCookieCount()));
SetWindowText(LPCTSTR(outBanner));

SetDlgItemInt(IDC_SELECT_COOKIE, Cookie->GetCookieCurrent() + 1);
}

/////////////////////////////////////////////////////////////////////////////


void CCookieDlg::OnBtnGoto() 
{
DoSpecific(GetDlgItemInt(IDC_SELECT_COOKIE) - 1);
}
