/////////////////////////////////////////////////////////////////////////////
//
// CookieText.CPP
//
// This used to be quick and dirty programming at its best!
// Now it is actually planned and implemented properly!  Gosh.
// AND, it even has comments - that mean something (sometimes)!!!
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CookieText.h"
#include "resource.h"

#ifdef _DEBUG
	#define new DEBUG_NEW
	#undef THIS_FILE
	static char THIS_FILE[] = __FILE__;
#endif

#include <time.h>
#include <stdio.h>
#include <winreg.h>
#include <malloc.h>

#include "xProgDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CCookieText Constructor
//
// Reads the index file into memory...
CCookieText::CCookieText(CWnd* pParent /* = NULL*/)
{
//Never know, may find a use for this...
    pParentWnd = pParent;

//Initialise various variables, not all strictly necissary but it is neat
    Cookie      = new CString("");
    CookieCount = 0;
    ShouldAbort = FALSE;
    ErrorResult = cERR_OK;
    mallocedIndex = FALSE;

    lCookieFileDate_Index = 0;
	hCookieFileDate_Index = 0;
	CookieFileSize_Index  = 0;
    CookieCount           = 0;
	CookieIndex           = 0;

	CookieFilename          = 0;
	lCookieFileDate_Current = 0;
	hCookieFileDate_Current = 0;
	CookieFileSize_Current  = 0;

//Initialise the ramdomiser
    srand((unsigned)time( NULL ));

// Now actually do something useful!
    try
        {
        // Get the data!
            if(DoFileStuff() == FALSE) throw(ErrorResult);
            if(DoRegistryStuff() == FALSE) throw(ErrorResult);
        
        // Check the data - errors don't count coz they will be overidden if the
        // index building is fucked.
            if(lCookieFileDate_Index != lCookieFileDate_Current)
                throw(ErrorResult = cERR_FILEMODIFIED);
            if(hCookieFileDate_Index != hCookieFileDate_Current) 
                throw(ErrorResult = cERR_FILEMODIFIED);
            if(CookieFileSize_Index != CookieFileSize_Current) 
                throw(ErrorResult = cERR_FILEMODIFIED);

        // Whilst debugging we wish to force reindexing so...
            #ifdef _DEBUG
                ShouldAbort == FALSE;
                throw(ErrorResult);
            #endif
        } // try block
    // Ooops, there is a problem
    catch(UINT WhichError)
        {
        // Okay, so this bit isn't needed but it stops compiler complaints!
            ErrorResult = WhichError;

        // Build an index if this is an error we can deal with...
            if(ShouldAbort == FALSE)
                if (BuildIndex() != FALSE)
                    {
                    // If we get to this point then the Registry has already been
                    // read once.  So, we need to reset the Index so we can read
                    // Registry again without mallocing on a malloced pointer! And
                    // thereby getting leaky memory.
                        if(mallocedIndex)
                            {
                            free(CookieIndex);
                            mallocedIndex = FALSE;
                            }
                    // Read the registry.  If this don't work then the program is
                    // well and truly screwed.
                        if (DoRegistryStuff() == FALSE)
                            ShouldAbort = TRUE;
                    }
        } // catch block
// That's all folks - Constructor
}

/////////////////////////////////////////////////////////////////////////////
ULONG CCookieText::GetCookieCount()
{
return CookieCount;
}

/////////////////////////////////////////////////////////////////////////////
ULONG CCookieText::GetCookieCurrent()
{
return (CurrentCookie);
}

/////////////////////////////////////////////////////////////////////////////
// CCookieText::GetRandomQuote()
//      No ERRORS Generated
CString* CCookieText::GetRandomCookie()
{
return GetSpecificCookie(rand() % CookieCount);
}

/////////////////////////////////////////////////////////////////////////////
// CString* CCookieText::GetSpecificCookie(UINT CookieNum)
//      No ERRORS Generated
CString* CCookieText::GetSpecificCookie(UINT CookieNum)
{
if (ShouldAbort)
    {
    CString     fmtError;

    // There is an error so format it properly and display that
    // instead of a cookie (i.e. don't actually abort but continue
    // without a cookie)...
        fmtError.LoadString(ErrorResult);
        Cookie->Format(fmtError, ErrorResult);
    }
else
    {   // If we've got this far, it is a safe bet that it all works so no error
        // checking is done on the I/O.
    LONG        cfOffset;
    DWORD       cfAmount;
    char        *bufCookie;
    HANDLE      hndCookieFile;
    DWORD       cfRead;         // Ignored!

    // First calculate some useful numbers    
        cfOffset = CookieIndex[CookieNum];
        cfAmount = CookieIndex[CookieNum + 1] - CookieIndex[CookieNum] - 1;

    // Then create a buffer to fit the thought
        bufCookie = new char[cfAmount + 1];

    // Now open the file, move to the correct place and read a cookie
        hndCookieFile = CreateFile((char*)(&CookieFilenamePath), 
            GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
        SetFilePointer(hndCookieFile, cfOffset, NULL, FILE_BEGIN);
        ReadFile(hndCookieFile, bufCookie, cfAmount, &cfRead, NULL);
    
    //Append a NULL to stop any overruns
        bufCookie[cfAmount] = 0;
    
    // Store the cookie in the CString which was created for the purpose
        *Cookie = bufCookie;
        CurrentCookie = CookieNum;


    // Finally, remember to tidy up!
        CloseHandle (hndCookieFile);
        delete(bufCookie);
    }
return Cookie;
}

/////////////////////////////////////////////////////////////////////////////
// CCookieText destructor
//
// De-allocates anything that needs de-allocating...
CCookieText::~CCookieText()
{
if(mallocedIndex)
    free(CookieIndex);
delete Cookie;
}

/////////////////////////////////////////////////////////////////////////////
// CCookieText::DoFileStuff() 
//      ERRORS are all 501?
// Gets the quote file info from the file
BOOL CCookieText::DoFileStuff()
{
HANDLE                      hndCookieFile;
BY_HANDLE_FILE_INFORMATION  infCookieFile;

// Find the cookie file
    if (0 == SearchPath(NULL, COOKIE_FILE, NULL, COOKIE_FILE_MAXPATH,
           (char*)(&CookieFilenamePath), &CookieFilename))
        return !(ShouldAbort = !( (ErrorResult = cERR_FILEFIND) == 0 ));

//Now play with the handle we just got...
    try
        {
        // Now open it
            if (INVALID_HANDLE_VALUE == (hndCookieFile = CreateFile((char*)
                    (&CookieFilenamePath), GENERIC_READ, 0, 0, OPEN_EXISTING, 
                    FILE_ATTRIBUTE_NORMAL, 0)))
                throw !(ShouldAbort = !( (ErrorResult = cERR_FILEOPEN) == 0 ));

        // Get the info about it
            if (FALSE == GetFileInformationByHandle(hndCookieFile, &infCookieFile))
                throw !(ShouldAbort = !( (ErrorResult = cERR_FILEQUERY) == 0 ));
        }
    // Ooops, there is a problem
    catch(UINT retVal)
        {
        //Aaaargh, something went wrong.  Clean up then exit.
            CloseHandle (hndCookieFile);
            return retVal;
        }
// We don't need the file any more...
    CloseHandle (hndCookieFile);
// But we do need to make a note of the pertinant info...

// First the modification date!
    lCookieFileDate_Current = infCookieFile.ftLastWriteTime.dwLowDateTime;
    hCookieFileDate_Current = infCookieFile.ftLastWriteTime.dwHighDateTime;

// Now the Size.  Okay, so this line limits the maximum size to 4GB 
// but we'll just have to work round this limitation.
    CookieFileSize_Current  = infCookieFile.nFileSizeLow;

// That's it, if we get to here all is OK, so...
    ErrorResult = cERR_FILEUNDEFINED;
    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CCookieText::DoRegistryStuff() 
//      ERRORS are all 502?
// Gets the quote Index and info info from the registry
BOOL CCookieText::DoRegistryStuff()
{
HKEY    hndRegistry;
DWORD   Result;
DWORD   ValSize;

// Get a handle on the Registry
    if (ERROR_SUCCESS != RegCreateKeyEx(HKEY_CLASSES_ROOT, COOKIE_REG_KEY, 0, "",
            REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hndRegistry, &Result) )
        return !(ShouldAbort = !( (ErrorResult = cERR_REGOPEN) == 0 ));

//Now play with the handle we just got...
    try
        {
        //If a new handle was created then return but don't abort
            if (Result == REG_CREATED_NEW_KEY)
                throw (UINT)(ShouldAbort = ( (ErrorResult = cERR_REGEMPTY) == 0 ));

        //Now get the other crap from the registry...
            ValSize = sizeof(DWORD);
            if(ERROR_SUCCESS != RegQueryValueEx(hndRegistry, COOKIE_REG_MOD_LOW,
                    NULL, NULL, (BYTE*)&lCookieFileDate_Index, &ValSize))
                throw (UINT)(ShouldAbort = ( (ErrorResult = cERR_REGEMPTY) == 0 ));
            if(ERROR_SUCCESS != RegQueryValueEx(hndRegistry, COOKIE_REG_MOD_HIGH, 
                    NULL, NULL, (BYTE*)&hCookieFileDate_Index, &ValSize))
                throw (UINT)(ShouldAbort = ( (ErrorResult = cERR_REGEMPTY) == 0 ));
            if(ERROR_SUCCESS != RegQueryValueEx(hndRegistry, COOKIE_REG_SIZE, 
                    NULL, NULL, (BYTE*)&CookieFileSize_Index, &ValSize))
                throw (UINT)(ShouldAbort = ( (ErrorResult = cERR_REGEMPTY) == 0 ));
            if(ERROR_SUCCESS != RegQueryValueEx(hndRegistry, COOKIE_REG_COUNT, 
                    NULL, NULL, (BYTE*)&CookieCount, &ValSize))
                throw (UINT)(ShouldAbort = ( (ErrorResult = cERR_REGEMPTY) == 0 ));
        
        // Now read the actual index into memory...
            if(NULL == (CookieIndex = (DWORD*)malloc((CookieCount + 1) * sizeof(DWORD))))
                throw (UINT)(ShouldAbort = ( (ErrorResult = cERR_REGMALLOC) == 0 ));
            mallocedIndex = TRUE;
            ValSize = _msize(CookieIndex);
            if(ERROR_SUCCESS != RegQueryValueEx(hndRegistry, COOKIE_REG_INDEX,
                    NULL, NULL, (BYTE*)CookieIndex, &ValSize))
                {
                // Deallocate and reset so destructor don't crash!
                // Could leave it to the destructor but I tend to forget these things
                free (CookieIndex);
                CookieIndex = 0;  
                throw (UINT)(ShouldAbort = ( (ErrorResult = cERR_REGEMPTY) == 0 ));
                }
        }
    // Ooops, there is a problem
    catch(UINT retVal)
        {
        //Aaaargh, something went wrong.  Clean up then exit.
            RegCloseKey(hndRegistry);
            return retVal;
        }

// That's it, if we get to here all is OK, so...
    ErrorResult = cERR_REGUNDEFINED;
    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CCookieText::BuildIndex() 
//      ERRORS are all 503?
// Gets the quote Index info and info info into the registry info???
// This could be a bit of a speed black-spot so it may get a bit hairy!
// On any failure this function aborts the whole thing!
BOOL CCookieText::BuildIndex()
{
HANDLE      hndCookieFile;
char        *bufCookieFile  = 0;
DWORD       *bufIndex       = 0;
DWORD	    CharsChecked    = 0;
DWORD       CharsToRead     = 0;
DWORD       CharsRead       = 0;
UINT        BlocksRead      = 0;
UINT        fbOffset        = 0;       
UINT        fiOffset        = 0;

CXProgressDlg   *ProgressDlg;

// Initialise Progress Bar
    ProgressDlg = new CXProgressDlg(pParentWnd);
    ProgressDlg->SetRange(0, ((CookieFileSize_Current / SIZE_FILE_BUFFER) + 1));
    ProgressDlg->SetStep(1);

try
    {
    // Open the soding thing...
        if (INVALID_HANDLE_VALUE == (hndCookieFile = CreateFile((char*)
                (&CookieFilenamePath), GENERIC_READ, 0, 0, OPEN_EXISTING, 
                FILE_ATTRIBUTE_NORMAL, 0)))
            throw (UINT)(!(ShouldAbort = !( (ErrorResult = cERR_BUILDFILEOPEN) == 0 )));
    // Allocate a storage buffer for file I/O
        if (NULL == (bufCookieFile = (char*)malloc (SIZE_FILE_BUFFER)))
            throw (UINT)(!(ShouldAbort = !( (ErrorResult = cERR_BUILDFILEBUF) == 0 )));
    // Allocate 1 byte of storage and set it to zero.
        if (NULL == (bufIndex = (DWORD*)malloc (sizeof(DWORD))))
            throw (UINT)(!(ShouldAbort = !( (ErrorResult = cERR_BUILDINDEXBUF) == 0 )));
        bufIndex[fiOffset++] = 0;
    //Now do some building
    CharsChecked = 0;
    CookieCount  = 0;
    do // WHILE(CharsChecked < CookieFileSize_Index)
        {
        if ((CookieFileSize_Current - CharsChecked) < SIZE_FILE_BUFFER)
            CharsToRead = CookieFileSize_Current - CharsChecked;
        else
            CharsToRead = SIZE_FILE_BUFFER;
        if(FALSE == ReadFile(hndCookieFile, bufCookieFile, CharsToRead, &CharsRead, NULL))
            throw (UINT)(!(ShouldAbort = !( (ErrorResult = cERR_BUILDFILEREAD) == 0 )));
        BlocksRead++;
        for(fbOffset = 0; fbOffset < CharsRead; fbOffset++)
            {
            if (bufCookieFile[fbOffset] == 0x0C)  // A magic number, oooh (0x0C == Page Break)
                {
                if ( (CookieCount % INDEX_BUFFER_COUNT) == 0 )
                    {
                    if (NULL == ( bufIndex = (DWORD*)realloc 
                            (bufIndex, (_msize(bufIndex) 
                                + (INDEX_BUFFER_COUNT * sizeof(DWORD)))) ))
                        throw (UINT)(!(ShouldAbort = !( (ErrorResult = cERR_BUILDINDEXBUF) == 0 )));
                    }
                bufIndex[fiOffset++] = (((BlocksRead - 1) * SIZE_FILE_BUFFER) + fbOffset + 1);
                CookieCount++;
                }
            }
        CharsChecked += CharsRead;
        ProgressDlg->DoStep();
        } //for(fbOffset = 0; fbOffset < CharsRead; fbOffset++)
    while (CharsChecked < CookieFileSize_Current);
    } //try
// Ooops, there's a problem
catch(UINT retVal)
    {
    //Aaaargh, something went wrong.  Clean up then exit.
        free (bufIndex);
        delete ProgressDlg;
        free (bufCookieFile);
        CloseHandle (hndCookieFile);
        return retVal;
    }
delete ProgressDlg;
free (bufCookieFile);
CloseHandle (hndCookieFile);

HKEY        hndRegistry;
DWORD       Result;

// Get a handle on the Registry
    if (ERROR_SUCCESS != RegCreateKeyEx(HKEY_CLASSES_ROOT, COOKIE_REG_KEY, 0, "",
            REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hndRegistry, &Result) )
        return !(ShouldAbort = !( (ErrorResult = cERR_BUILDREGOPEN) == 0 ));

// Now put all the shit in the Registry...
try // nothing actually throws an exception in this block 'coz if it isn't
    // working by now it never will (and a could not be arsed).
    {     
    RegSetValueEx(hndRegistry, COOKIE_REG_MOD_LOW, NULL, REG_DWORD,
            (BYTE*)&lCookieFileDate_Current, sizeof(DWORD));
    RegSetValueEx(hndRegistry, COOKIE_REG_MOD_HIGH, NULL, REG_DWORD,
            (BYTE*)&hCookieFileDate_Current, sizeof(DWORD));
    RegSetValueEx(hndRegistry, COOKIE_REG_SIZE, NULL, REG_DWORD,
            (BYTE*)&CookieFileSize_Current, sizeof(DWORD));
    RegSetValueEx(hndRegistry, COOKIE_REG_COUNT, NULL, REG_DWORD,
            (BYTE*)&CookieCount, sizeof(DWORD));
    RegSetValueEx(hndRegistry, COOKIE_REG_INDEX, NULL, REG_BINARY,
            (BYTE*)bufIndex, ((CookieCount + 1) * sizeof(DWORD)));
    RegCloseKey(hndRegistry);
   }
catch(UINT RetVal) // Later
    {
    RetVal = 0;  // Stop compiler moans!
    RegCloseKey(hndRegistry);
    free (bufIndex);
    ShouldAbort = TRUE;
    ErrorResult = cERR_BUILDUNDEFINED;
    return FALSE;
    }
RegCloseKey(hndRegistry);
free (bufIndex);

// Clear the progress bar
    //delete...

// That's it, if we get to here all is OK, so...
    ErrorResult = cERR_BUILDUNDEFINED;
    return TRUE;
}