/////////////////////////////////////////////////////////////////////////////
//
// CookieText.h
//
// Introducing the CCookieText Class.
//
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Useful Definitions to allow quick tweaking!

//Set the name of the cookie file etc.
    #define COOKIE_FILE             "COOKIE.TXT"
    #define COOKIE_FILE_MAXPATH     512

//Set the Registry details
    #define COOKIE_REG_KEY          "...xaphod's\\Cookie2"
    #define COOKIE_REG_MOD_LOW      "CookieFile_LastModified_Low"
    #define COOKIE_REG_MOD_HIGH     "CookieFile_LastModified_High"  // Love a good high!
    #define COOKIE_REG_SIZE         "CookieFile_Size"
    #define COOKIE_REG_COUNT        "Cookie_Count"
    #define COOKIE_REG_INDEX        "Cookie_Index"

// Buffer sizes, 16KB and 512 DWORDS
    #define SIZE_FILE_BUFFER        16384
    #define INDEX_BUFFER_COUNT      512

/////////////////////////////////////////////////////////////////////////////
// CCookieText
class CCookieText
{
public:     //Screw with this stuff at will
			CCookieText(CWnd* pParent = NULL);

	ULONG   GetCookieCurrent();
	ULONG   GetCookieCount();

	CString *GetRandomCookie();
	CString *GetSpecificCookie(UINT CookieNum);

			~CCookieText();
	
protected:   // Don't screw with this stuff, unless you really want to

//Functions:
    BOOL    DoFileStuff();      // Called by the constructor only
    BOOL    DoRegistryStuff();  // Called by the constructor only
    BOOL    BuildIndex();       // Called by the constructor only

// Data for the object to run propper
	char	CookieFilenamePath[COOKIE_FILE_MAXPATH];
	char	*CookieFilename;
    ULONG   CurrentCookie;          // Index of the cookie in Cookie
    CString *Cookie;                // The Cookie

// Data from the Registry
	DWORD	lCookieFileDate_Index;  // Last modified low order DWORD
	DWORD	hCookieFileDate_Index;  // Last modified high order DWORD
	DWORD	CookieFileSize_Index;   // Size of the file
    DWORD   CookieCount;            // duh, wonder what this does?
	DWORD	*CookieIndex;           // The Cookiefile index, see mallocedIndex

//Data from the cookie file
	DWORD	lCookieFileDate_Current;    // Last modified low order DWORD
	DWORD	hCookieFileDate_Current;    // Last modified high order DWORD
	DWORD	CookieFileSize_Current;     // Size of the file

private:  // Don't screw with this stuff, even if you really want to!

// Data for the object to run propper
    CWnd    *pParentWnd;    // Parent!
    BOOL    ShouldAbort;    // FLAG: Raised to trap serious errors
    BOOL    mallocedIndex;  // FLAG: Has the CookieIndex been allocated space on heap
    UINT    ErrorResult;    // Tracks any errors
};
/////////////////////////////////////////////////////////////////////////////
